unit Datedemo;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, AdDate, adweek,
  TabNotBk, Spin;

type
  TTAdrockDatesForm = class(TForm)
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    PrevBusinessDayLabel: TLabel;
    IsHolidayLabel: TLabel;
    IsBusinessHolidayLabel: TLabel;
    NextBusinessDayLabel: TLabel;
    isBusinessDayLabel: TLabel;
    Panel3: TPanel;
    HolidaylistBox: TListBox;
    GroupBox3: TGroupBox;
    Bevel4: TBevel;
    Bevel9: TBevel;
    Bevel8: TBevel;
    Label34: TLabel;
    DaysBetweenDatesLabel: TLabel;
    Label38: TLabel;
    WeeksBetweenDatesLabel: TLabel;
    Label40: TLabel;
    MonthsBetweenDatesLabel: TLabel;
    Label42: TLabel;
    YearsBetweenDatesLabel: TLabel;
    Label36: TLabel;
    BoundryWeeksBetweenDatesLabel: TLabel;
    Label39: TLabel;
    BoundryMonthsBetweenDatesLabel: TLabel;
    Label43: TLabel;
    BoundryYearsBetweenDatesLabel: TLabel;
    Label45: TLabel;
    BoundryQuartersBetweenDatesLabel: TLabel;
    Label64: TLabel;
    QuartersBetweenDatesLabel: TLabel;
    Label31: TLabel;
    DaysAgoLabel: TLabel;
    Label33: TLabel;
    WeeksAgoLabel: TLabel;
    Label35: TLabel;
    MonthsAgoLabel: TLabel;
    Label37: TLabel;
    YearsAgoLabel: TLabel;
    Label46: TLabel;
    QuartersAgoLabel: TLabel;
    GroupBox6: TGroupBox;
    Label51: TLabel;
    AddDateLabel: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    DateDiffLabel: TLabel;
    SelectedDatelabel1: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label66: TLabel;
    AddDateType: TEdit;
    AddDateNumber: TEdit;
    DateDiffType: TEdit;
    UpdateAddDateButton: TBitBtn;
    UpdateDateDiffButton: TBitBtn;
    GroupBox1: TGroupBox;
    Label48: TLabel;
    SelectedDatePlus1DayLabel: TLabel;
    Label50: TLabel;
    Label47: TLabel;
    Label54: TLabel;
    SelectedDatePlus1WeekLabel: TLabel;
    SelectedDatePlus1MonthLabel: TLabel;
    SelectedDatePlus1YearLabel: TLabel;
    Label49: TLabel;
    SelectedDateMinus1DayLabel: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label55: TLabel;
    SelectedDateMinus1WeekLabel: TLabel;
    SelectedDateMinus1MonthLabel: TLabel;
    SelectedDateMinus1YearLabel: TLabel;
    Panel4: TPanel;
    Label95: TLabel;
    Panel1: TGroupBox;
    WorkDateField: TComboBox;
    Panel5: TPanel;
    LabelValidDate: TLabel;
    GroupBox7: TGroupBox;
    Bevel3: TBevel;
    Label79: TLabel;
    isJanuaryLabel: TLabel;
    Label81: TLabel;
    isMarchLabel: TLabel;
    Label83: TLabel;
    isFebruarylabel: TLabel;
    Label67: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    Label91: TLabel;
    Label68: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    isAprilLabel: TLabel;
    isMayLabel: TLabel;
    isJulylabel: TLabel;
    isAugustLabel: TLabel;
    isSeptemberLabel: TLabel;
    isOctoberLabel: TLabel;
    IsDecemberLabel: TLabel;
    isNovemberLabel: TLabel;
    isJuneLabel: TLabel;
    LabelValidTime: TLabel;
    LabelValidDateTime: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    VerbalLabel: TLabel;
    Bevel1: TBevel;
    DayOfWeek: TComboBox;
    WeekNumberStyle: TComboBox;
    Label3: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Bevel2: TBevel;
    DayOfYearLabel: TLabel;
    Label32: TLabel;
    Label28: TLabel;
    WeekOfYearLabel: TLabel;
    Label24: TLabel;
    CenturyLabel: TLabel;
    Quarter: TLabel;
    QuarterLabel: TLabel;
    Label29: TLabel;
    DayThLabel: TLabel;
    Label1: TLabel;
    DaysLeftInYearLabel: TLabel;
    Label63: TLabel;
    DayOfMonthLabel: TLabel;
    Label62: TLabel;
    DaysLeftInMonthLabel: TLabel;
    Label30: TLabel;
    WeekOfMonthLabel: TLabel;
    Label12: TLabel;
    LabelDayOfWeek: TLabel;
    Label72: TLabel;
    FirstOfAWeekLabel: TLabel;
    Label78: TLabel;
    LastOfAWeekLabel: TLabel;
    Label13: TLabel;
    FirstOfAMonthLabel: TLabel;
    Label15: TLabel;
    LastofAMonthLabel: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Bevel5: TBevel;
    Label17: TLabel;
    LabelCountDownToY2K: TLabel;
    Timer1: TTimer;
{    procedure UpdateAddDateButtonClick(Sender: TObject);}
    procedure FormCreate(Sender: TObject);
    procedure UpdateDateDiffButtonClick(Sender: TObject);
    procedure RefreshButtonClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure UpdateAddDateButtonClick(Sender: TObject);
    procedure WorkDateFieldChange(Sender: TObject);
    procedure WeekNumberStyleChange(Sender: TObject);
    procedure DayOfWeekChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Function ReturnYesNo(State : Boolean) : String;
    procedure UpdateY2K;
    procedure Refresh;
  end;

var
  TAdrockDatesForm: TTAdrockDatesForm;
  CellsImage  : Array [1..42] of String;
  Cells       : Array [1..42] of String;

implementation

{$R *.DFM}



procedure TTAdrockDatesForm.FormCreate(Sender: TObject);
begin
 DayOfWeek.Itemindex := 0;
 WeekNumberStyle.ItemIndex := 0;
 Refresh;
end;


procedure TTAdrockDatesForm.UpdateY2K;
var
 fHours, fMins, fSecs, fDays : Integer;
begin
  if (IsValidAdrockDateTime(WorkDateField.Text)) then
   begin
      TimeDiff(EncodeDate(2000,1,1), AdrockStrToDateTime(WorkDateField.Text), fHours, fMins, fSecs);
      fDays := fHours div 24;
      fHours := fHours Mod 24;
      LabelCountDownToY2K.Caption := intToStr(fDays)+' days, '+intToStr(fHours)+' hours, '+IntTostr(fmins)+' mins, '+IntTostr(fSecs)+' secs';
   end
  else
    LabelCountDownToY2K.Caption := ''; 
end;

procedure TTAdrockDatesForm.Refresh;
Var
 fHours, fMins, fSecs, fDays : Integer;
 WorkDate : TDateTime;
 OK : Boolean;
begin
  OK := FALSE;
  if (IsValidAdrockDate(WorkDateField.Text)) then
    LabelValidDate.Caption := FormatDate('DDDD DZ, MMMM, YYYY', AdrockStrToDateTime(WorkDateField.Text))
  else
    LabelValidDate.Caption := 'Not Valid';


  if (IsValidAdrockTime(WorkDateField.Text)) then
    LabelValidTime.Caption := FormatDate('HH:MM:SS', AdrockStrToTime(WorkDateField.Text))
  else
    LabelValidTime.Caption := 'Not Valid';

  if (IsValidAdrockDateTime(WorkDateField.Text)) then
   begin
      LabelValidDateTime.Caption := FormatDate('DDDD DZ, MMMM, YYYY  HH:MM:SS', AdrockStrToDateTime(WorkDateField.Text));
      OK := TRUE;
    end
  else
    LabelValidDateTime.Caption := 'Not Valid';

     { The functions that are using 2 mean that the starting ssay of the week is a }
     { monday, Since 1=Sunday, 2=Monday, etc.. }

     { Set the holiday string list.This string list contains dates that refer to holidays, the IsHoliday function uses
       the holiday list if it is found to test for holidays, and the business functions except for IsBusinessDay also
       use the holidays string list, it is has been defined.
     }
     SetHolidayStringList(HolidaylistBox.Items);
     if (OK = TRUE) then
       begin
        WorkDate := AdrockStrToDateTime(WorkDateField.Text);

        DayOfYearLabel.Caption := IntToStr(ReturnDayOfYear(WorkDate));
        DaysLeftInyearLabel.Caption := IntToStr(DaysLeftInyear(WorkDate));
        DayOfMonthLabel.Caption := IntToStr(ReturnDayOfMonth(WorkDate));
        DaysLeftInMonthLabel.Caption := IntToStr(DaysLeftInMonth(WorkDate));
        WeekOfMonthLabel.Caption := IntToStr(ReturnWeekofMonth(2, WorkDate));

        WeekOfYearLabel.Caption := IntToStr(WeekOfYear(WorkDate, TAdrockWeekDay(DayOfWeek.Itemindex), TAdrockWeekStyle(WeekNumberStyle.ItemIndex)));
        QuarterLabel.Caption := IntToStr(ReturnQuarter(WorkDate));
        CenturyLabel.Caption := IntToStr(ReturnCentury(WorkDate));

        DayThLabel.Caption := ReturnDayTh(WorkDate)+',  '+
          IntToStr(ReturnDayOfMonth(WorkDate))+
          ReturnDayTh(WorkDate);

        LabelDayOfWeek.Caption := LongMonthNames[SysUtils.DayofWeek(WorkDate)];
        DaysAgoLabel.Caption := ReturnDaysAgo(WorkDate);
        WeeksAgoLabel.Caption := ReturnWeeksAgo(2, WorkDate);
       MonthsAgoLabel.Caption := ReturnMonthsAgo(WorkDate);
        QuartersAgoLabel.Caption := ReturnQuartersAgo(WorkDate);
        YearsAgoLabel.Caption := ReturnYearsAgo(WorkDate);

        DaysBetweenDatesLabel.Caption := IntToStr(ReturnDaysBetweenDates(WorkDate, Date));
   (*     BusinessDaysBetweenDatesLabel.Caption :=
            IntToStr(ReturnBusinessDaysBetweenDates(WorkDate, Date));
   *)
        WeeksBetweenDatesLabel.Caption := IntToStr(ReturnWeeksBetweenDates(WorkDate, Date));
        MonthsBetweenDatesLabel.Caption := IntToStr(ReturnMonthsBetweenDates(WorkDate, Date));
        QuartersBetweenDatesLabel.Caption := IntToStr(ReturnQuartersBetweenDates(WorkDate, Date));
        YearsBetweenDatesLabel.Caption := IntToStr(ReturnYearsBetweenDates(WorkDate, Date));

        BoundryWeeksBetweenDatesLabel.Caption :=
            IntToStr(ReturnBoundaryWeeksBetweenDates(2, WorkDate, Date));
        BoundryMonthsBetweenDatesLabel.Caption :=
            IntToStr(ReturnBoundaryMonthsBetweenDates(WorkDate, Date));
        BoundryQuartersBetweenDatesLabel.Caption :=
            IntToStr(ReturnBoundaryQuartersBetweenDates(WorkDate, Date));
        BoundryYearsBetweenDatesLabel.Caption :=
            IntToStr(ReturnBoundaryYearsBetweenDates(WorkDate, Date));

        SelectedDatelabel1.Caption      := AdrockDateToStr(Date);
        SelectedDatePlus1DayLabel.Caption    := AdrockDateToStr(AddDays(1, WorkDate));
        SelectedDatePlus1WeekLabel.Caption   := AdrockDateToStr(AddWeeks(1, WorkDate));
        SelectedDatePlus1MonthLabel.Caption  := AdrockDateToStr(AddMonths(1, WorkDate));
        SelectedDatePlus1YearLabel.Caption   := AdrockDateToStr(AddYears(1, WorkDate));

        SelectedDateMinus1DayLabel.Caption    := AdrockDateToStr(AddDays(-1, WorkDate));
        SelectedDateMinus1WeekLabel.Caption   := AdrockDateToStr(AddWeeks(-1, WorkDate));
        SelectedDateMinus1MonthLabel.Caption  := AdrockDateToStr(AddMonths(-1, WorkDate));
        SelectedDateMinus1YearLabel.Caption   := AdrockDateToStr(AddYears(-1, WorkDate));

        isBusinessDayLabel.Caption                 := ReturnYesNo(IsBusinessDay(WorkDate));
        IsHolidayLabel.Caption                     := ReturnyesNo(IsHoliday(WorkDate));
        isBusinessHolidayLabel.Caption             := ReturnyesNo(isBusinessHoliday(WorkDate));

   (*
        isMondayLabel.Caption                 := ReturnYesNo(IsMonday(WorkDate));
        isTuesdayLabel.Caption                := ReturnYesNo(IsTuesday(WorkDate));
        isWednesdayLabel.Caption              := ReturnYesNo(IsWednesday(WorkDate));
        isThursdayLabel.Caption               := ReturnYesNo(IsThursday(WorkDate));
        isFridayLabel.Caption                 := ReturnYesNo(IsFriday(WorkDate));
        isSaturdayLabel.Caption               := ReturnYesNo(IsSaturday(WorkDate));
        isSundayLabel.Caption                 := ReturnYesNo(IsSunday(WorkDate));

        isWeekendLabel.Caption                := ReturnYesNo(IsWeekend(WorkDate));
        isWeekdayLabel.Caption                := ReturnYesNo(IsWeekday(WorkDate));

        isChristmasDayLabel.Caption           := ReturnYesNo(IsChristmasDay(WorkDate));
        isNewYearsDayLabel.Caption            := ReturnYesNo(IsNewYearsDay(WorkDate));
   *)
        isJanuaryLabel.Caption                := ReturnYesNo(IsJanuary(WorkDate));
        isFebruaryLabel.Caption               := ReturnYesNo(IsFebruary(WorkDate));
        isMarchLabel.Caption                  := ReturnYesNo(IsMarch(WorkDate));
        isAprilLabel.Caption                  := ReturnYesNo(IsApril(WorkDate));
        isMayLabel.Caption                    := ReturnYesNo(IsMay(WorkDate));
        isJuneLabel.Caption                   := ReturnYesNo(IsJune(WorkDate));
        isJulyLabel.Caption                   := ReturnYesNo(IsJuly(WorkDate));
        isAugustLabel.Caption                 := ReturnYesNo(IsAugust(WorkDate));
        isSeptemberLabel.Caption              := ReturnYesNo(IsSeptember(WorkDate));
        isOctoberLabel.Caption                := ReturnYesNo(IsOctober(WorkDate));
        isNovemberLabel.Caption               := ReturnYesNo(IsNovember(WorkDate));
        isDecemberLabel.Caption               := ReturnYesNo(IsDecember(WorkDate));

        NextBusinessDayLabel.Caption := AdrockDateToStr(NextBusinessDay(WorkDate));
        PrevBusinessDayLabel.Caption := AdrockDateToStr(PrevBusinessDay(WorkDate));

        VerbalLabel.Caption := VerbalDate(WorkDate);

        FirstOfAWeekLabel.Caption := AdrockDateToStr(ReturnFirstOfAWeek(2, WorkDate));
        LastOfAWeekLabel.Caption  := AdrockDateToStr(ReturnLastOfAWeek(2, WorkDate));
        FirstofAMonthLabel.Caption  := AdrockDateToStr(ReturnFirstOfGivenMonth(WorkDate));
        LastofAMonthLabel.Caption  := AdrockDateToStr(ReturnLastOfGivenMonth(WorkDate));

        UpdateAddDateButtonClick(Self);
        UpdateDateDiffButtonClick(Self);

        UpdateY2K;
   end
  else
    begin
        LabelCountDownToY2K.Caption := '';
        DayOfYearLabel.Caption := '';
        DaysLeftInyearLabel.Caption := '';
        DayOfMonthLabel.Caption := '';
        DaysLeftInMonthLabel.Caption := '';
        WeekOfMonthLabel.Caption := '';
        LabelDayOfWeek.Caption := '';

        WeekOfYearLabel.Caption := '';
        QuarterLabel.Caption := '';
        CenturyLabel.Caption := '';

        DayThLabel.Caption := '';
        DaysAgoLabel.Caption := '';
        WeeksAgoLabel.Caption := '';
        MonthsAgoLabel.Caption := '';
        QuartersAgoLabel.Caption := '';
        YearsAgoLabel.Caption := '';

        DaysBetweenDatesLabel.Caption := '';
        WeeksBetweenDatesLabel.Caption := '';
        MonthsBetweenDatesLabel.Caption := '';
        QuartersBetweenDatesLabel.Caption := '';
        YearsBetweenDatesLabel.Caption := '';

        BoundryWeeksBetweenDatesLabel.Caption := '';
        BoundryMonthsBetweenDatesLabel.Caption :='';
        BoundryQuartersBetweenDatesLabel.Caption :='';
        BoundryYearsBetweenDatesLabel.Caption := '';

        SelectedDatelabel1.Caption            := '';
        SelectedDatePlus1DayLabel.Caption     := '';
        SelectedDatePlus1WeekLabel.Caption    := '';
        SelectedDatePlus1MonthLabel.Caption   := '';
        SelectedDatePlus1YearLabel.Caption    := '';

        SelectedDateMinus1DayLabel.Caption    := '';
        SelectedDateMinus1WeekLabel.Caption   := '';
        SelectedDateMinus1MonthLabel.Caption  := '';
        SelectedDateMinus1YearLabel.Caption   := '';

        isBusinessDayLabel.Caption            := '';
        IsHolidayLabel.Caption                := '';
        isBusinessHolidayLabel.Caption        := '';

        isJanuaryLabel.Caption                := '';
        isFebruaryLabel.Caption               := '';
        isMarchLabel.Caption                  := '';
        isAprilLabel.Caption                  := '';
        isMayLabel.Caption                    := '';
        isJuneLabel.Caption                   := '';
        isJulyLabel.Caption                   := '';
        isAugustLabel.Caption                 := '';
        isSeptemberLabel.Caption              := '';
        isOctoberLabel.Caption                := '';
        isNovemberLabel.Caption               := '';
        isDecemberLabel.Caption               := '';

        NextBusinessDayLabel.Caption          := '';
        PrevBusinessDayLabel.Caption          := '';

        VerbalLabel.Caption                   := '';

        FirstOfAWeekLabel.Caption             := '';
        LastOfAWeekLabel.Caption              := '';
        FirstofAMonthLabel.Caption            := '';
        LastofAMonthLabel.Caption             := '';

        AddDateLabel.Caption                  := '';
        DateDiffLabel.Caption                 := '';
   end;
end;

Function TTAdrockDatesForm.ReturnYesNo(State : Boolean) : String;
begin
 if (State = TRUE) then
   Result := 'Yes'
 else
   Result := 'No';
end;

procedure TTAdrockDatesForm.UpdateDateDiffButtonClick(Sender: TObject);
begin
  SetHolidayStringList(HolidayListBox.Items);
  DateDiffLabel.Caption := IntToStr(DateDiff(DateDiffType.Text, 2, AdrockStrToDateTime(WorkDateField.Text),Date));
end;


procedure TTAdrockDatesForm.RefreshButtonClick(Sender: TObject);
begin
     Refresh;
end;

procedure TTAdrockDatesForm.SpinButton1DownClick(Sender: TObject);
begin
     WorkDateField.Text := AdrockDateToStr(StrToDate(WorkDateField.Text)-1);
     Refresh;
end;

procedure TTAdrockDatesForm.SpinButton1UpClick(Sender: TObject);
begin
     WorkDateField.Text := AdrockDateToStr(StrToDate(WorkDateField.Text)+1);
     Refresh;
end;

procedure TTAdrockDatesForm.UpdateAddDateButtonClick(Sender: TObject);
begin
  AddDateLabel.Caption :=AdrockDateToStr(AddDate(AddDateType.Text, StrToInt(AddDateNumber.Text),
    AdrockStrToDateTime(WorkDateField.Text)));
end;

procedure TTAdrockDatesForm.WorkDateFieldChange(Sender: TObject);
begin
  refresh;
end;

procedure TTAdrockDatesForm.WeekNumberStyleChange(Sender: TObject);
begin
  Refresh;
end;

procedure TTAdrockDatesForm.DayOfWeekChange(Sender: TObject);
begin
  Refresh;
end;

procedure TTAdrockDatesForm.Timer1Timer(Sender: TObject);
begin
  UpdateY2K;
end;

end.

